;
;Virogen's PE Shrinker v0.14
;(c)1999 Virogen/PC
;email: vgen@hotmail.com
;www: http://virogen.cjb.net
;----------------------------------------------------------------
; 
; This is a simple PE compressor utilizing the LZRW1 algorithm
; to compress code and data sections of a PE. Resource compression
; and section merging will be supported in later versions. 
;
;	Features:
;	   +Compression of code and data sections.
;	   +Calculates correct new checksum.
;	   +Realigns PE.
;	   +Small, fast decompressor.          	   	
;
; Usage:
;   -VGSHRINK filename
;
; Update: v0.11: Fixed bug like 10 minutes after initial release.
;		thanks to nIabI for testing.
; 	  v0.12: Optimized lzrw1 decompression code some
; 	  v0.13: Rewrote lzrw1 decompression procedure, vast improvement.
;		 Removed NULLing of destination buffer, not necessary
;		 I don't think.
;	  v0.14: +Fixed bug in LCC-WIN32 applications, where physical 
;	   	 size of of sections is, surprisingly enough, not aligned.
;		 +No longer flagged by AVP as suspicious.
;		 
;
include mywin.inc       

ID_OFF          equ     0ch    ; offset of our marker in PE
DECRYPTOR_SIZE  equ     (offset decryptor_code_end-offset decryptor_code)  ;
VIRTUAL_SIZE    equ     DECRYPTOR_SIZE
MAX_OBJS        equ     6               ; maximum objects we can handle
                                        ; by increasing this you are increasing the size
                                        ; of the table in decryptor by MAX_OBJS*8.

.386p
locals
jumps
.model flat,STDCALL

extrn   ExitProcess:PROC         
extrn   CreateFileA:PROC         
extrn   CloseHandle:PROC         
extrn   ReadFile:PROC            
extrn   WriteFile:PROC           
extrn   SetFilePointer:PROC      
extrn   MapViewOfFile:PROC       
extrn   CreateFileMappingA:PROC  
extrn   UnmapViewOfFile:PROC     
extrn   SetEndOfFile:PROC        
extrn   SetFilePointer:PROC      
extrn   GetFileAttributesA:PROC  
extrn   SetFileAttributesA:PROC  
extrn   GetFileSize:PROC         
extrn   GetFileSize:PROC         
extrn   GetFileTime:PROC         
extrn   SetFileTime:PROC         
extrn   CheckSumMappedFile:PROC  
extrn   MessageBoxA:PROC         
extrn   GetCommandLineA:PROC     
extrn   lstrcat:PROC             
extrn   IsBadReadPtr:PROC        
extrn   WriteConsoleA:PROC
extrn   GetStdHandle:PROC
extrn   ReadConsoleA:PROC
extrn	GlobalAlloc:PROC
extrn	GlobalFree:PROC


org 0  
.data                                   ; data object

cr      equ 0dh
lf      equ 0ah
tab     equ 9
hline   equ 196
marker  equ 90909090h

cr_lf_tab       db cr,lf,tab,tab,0
init_txt        db 50 dup(hline),cr,lf
caption         db 'Virogen''s PE Shrinker v0.14, (c)1998 Virogen/PC',0
badcmd_txt      db 'Invalid command line!',cr,lf,'Usage: VGSHRINK filename',cr,lf,0
success_txt	db 'Successfully compressed!'
file_txt        db cr,lf,' Installed on file: ',tab,0
                db 400 dup (0)          ; plenty of space
obj_txt         db cr,lf,' Installed in object: ',tab,0
                db 9 dup(0)
eobj_txt        db cr,lf,' Compressed objects: ',0
                db (MAX_OBJS*8)+1 dup(0)        
size_txt        db cr,lf,'Original size: ',0
		db 50 dup(0)
a_org_size	db 15 dup(0)
inter		db ' New size : ',0		
a_new_size	db 15 dup(0)
;append_question db 'Click YES to create a new section, or NO to append to last section.',0		
already_txt     db 'File appears to already be compressed.',0
error_txt       db 'There was an error compressing the file!',cr,lf
fname_txt       db 'Specified file: ',0
                db 260 dup(0)
creation        dd 0,0 
lastaccess      dd 0,0
lastwrite       dd 0,0
oldchksum       dd 0
new_fsize	dd 0
p_lz_mem	dd 0
fsize           dd 0
orgalign	dd 0
map_ptr         dd 0
oldattrib       dd 0   
fnameptr        dd 0   
ptrpeheader     dd 0
objPsize        dd 0
maphandle       dd 0
org_fsize	dd 0
handle          dd 0
objtblVA        dd 0
objptr          dd 0
lastobjimageoff dd 0
largest_needed_buffer dd 0
originalpsize   dd 0
originalvsize   dd 0
error           db -1                       ;
importtbl	dd 0
exporttbl       dd 0
file_alignment 	dd 0
byteswrote      dd 0
svd_imgbase	dd 0
csize		dd 0

bad_otbl:                       ; this is the list of bad objs - did I miss any?
   dd 'rsr.'                            ; rsrc
   dd 'ler.'                            ; relo
   dd 'ade.'                            ; edata
   dd 'ete.'                            ; etext
   dd 'adi.'                            ; idata
   dd 'adr.'                            ; rdata
   dd 'slt.'                            ; tls 
   dd 0                                 

;---- decompression symbiont code installed into file ---- 
;
;
unpre_reg2 equ ebx
unpre_reg equ edx                       ; the only register not
                                        ; preserved
decryptor_code:                         
        pushfd   
        push    ebp
        call    geteip                              ; find relative offset       
        xchg    unpre_reg,ebp
        pop     ebp
        pushad
        xchg    unpre_reg,ebp

        lea	esi,otable[ebp]
        lea	edi,dcomp_buffer[ebp]                
decomp_loop:
	push	edi esi
	lodsd
	or	eax,eax
	jz	decomp_done
	xchg	eax,edx
	; edx->object
	lodsd	
	xchg	eax,ecx
	; ecx=compressed size     	   
	push	edi ecx
	mov	esi,edx
	rep	movsb	
	pop	ecx edi	
        call	LZRW1_Decompress,edi,ecx,edx ;edx,ecx,edi                
        pop	esi edi
        add	esi,8
        jmp	decomp_loop
decomp_done:
	add	esp,8			; fixup stack from loop exit	
	                      
goto_entry:

       popad   
       popfd   
       mov	unpre_reg2,host_eip[unpre_reg]
       mov	[unpre_reg+host_eip],ecx
       jmp      unpre_reg2                   ; jump to host original entry                                         
                 
otable          dd ((MAX_OBJS+1)*2) dup (0)               
otable_end:
host_eip        dd 0                                      ; original host entry

encrypted_end:

geteip:         
        call    getme   
getme:
        mov     ebp,[esp]                             ; grab it off stack
        sub     ebp,offset getme                      ; fix it up
        add     esp,4                                 ; fix da stack
        ret

include lzrw1dec.asm		; LZRW1 decompression code

dcomp_buffer:
decryptor_code_end:
; --- end of decompressor code ---


; --- start of VGShrink ---
.code                                   ; code object - change flags to rwx
start:
        call    GetCommandLineA                 ; retrieve command line
        or      eax,eax                         
        jz      _exit_bad_cmd_line              ; if none then abort /w msg
        xchg    esi,eax
sl:
        cmp     byte ptr [esi],0                ; if first byte is NULL then something way wrong
        jz      _exit_bad_cmd_line    
        shl     eax,8                           ; rotate 1 byte in eax, for loop.. eax running load
        lodsb                       		    ; get next byte in al
        cmp     eax,'rink'                      ; end of our proggie name?
        jnz     not_eoc
        cmp     byte ptr [esi],'.'
        jnz     esl
not_eoc:    
        cmp     eax,'.exe'                      ; .exe end of our proggie name?
        jz      esl
        cmp     eax,'.EXE'                      ; .EXE end of our proggie name?
        jnz     sl
esl:
        lodsb
        cmp     al,' '
        jz      esl             
        cmp     al,'"'
        jz      esl
        dec     esi
esl2:    
        cmp     byte ptr [esi],0                ; if first char in parameter 1 is NULL then we fuq
        jz      _exit_bad_cmd_line    
        
        call    lstrcat,offset success_txt,esi                 ; append filename to success message
        mov     fnameptr,esi                    ; set fnameptr->filename
        call    CompressFile                     ; go encrypt                
        cmp     error,-4
        jz      _exit        
        cmp     error,-1                        ; error?
        jz      _exit_error                     ; if so go display error message
                        
        call    lstrcat,offset success_txt,offset obj_txt 
        call    lstrcat,offset success_txt,offset eobj_txt 
        call    lstrcat,offset success_txt,offset size_txt

        call    MessageBoxA,0,offset success_txt,offset caption,0
        xor     eax,eax           
        jmp     _exit             

_exit_error:
        call    lstrcat,offset error_txt,fnameptr
        call    MessageBoxA,0,offset error_txt,offset caption,MB_ICONEXCLAMATION
        mov     eax,2              
        jmp     _exit              
 
_exit_bad_cmd_line: 
        call    MessageBoxA,0,offset badcmd_txt,offset caption,MB_ICONEXCLAMATION
        xor     eax,eax           
        inc     eax               
_exit:    
        call    ExitProcess,eax

;-----------------------------------------------
; Compress file - call with fnameptr set
;
CompressFile proc

        call    GetFileAttributesA,fnameptr        
        mov     oldattrib,eax                                                      
                                                                                   
        cmp     eax,-1                             
        jnz     not_shared                                                         
        ret                                        

not_shared:
        call    SetFileAttributesA,fnameptr,20h    
        
        mov     esi,fnameptr
        call    OpenFile
        call    test_error
        jnc     open_ok
        ret         
open_ok:
        mov     handle,eax                                                                                                                                              
        call    GetFileTime,eax,offset lastwrite,offset lastaccess,offset creation   
                                                                                   
        xor     ecx,ecx                                ; only map size of file      
        call    create_mapping     
        jc      abort_encrypt                                                       
                                               ; eax->mapped file                
        cmp     word ptr [eax],'ZM'                    ; is EXE?                    
        jnz     abort_encrypt                                                       
                                                                                    
        call    GetPEHeader                           ; load esi->PE Header         
                                                                                    
        call    IsBadReadPtr,esi,2                     ; was ptr any good?       
        or      eax,eax                                                             
        jnz     abort_encrypt                                                       
                                                                                    
        cmp     word ptr [esi],'EP'                    ; PE?                        
        jnz     abort_encrypt                                                       
        cmp     dword ptr [esi+ID_OFF],marker   
        jnz     not_compressed     
        call    MessageBoxA,0,offset already_txt,offset caption,MB_ICONHAND                                                         
        mov	error,-4        
        jmp     abort_encrypt                                                       

not_compressed:
        call    unmap                                 ; unmap file                                   
                                                                                                     
        mov     ecx,1000h                             ; give us room to add to the file, if needed      
        call    create_mapping                        ; map file again                               
        jc      abort_encrypt                                                                        
                                                                                                     
        call    GetPEHeader                           ; load esi -> pe header                                                                                                                                     
                                                                                                     
        mov     dword ptr [esi+ID_OFF],marker          ; save marker                                 
                                                                                                     
        mov     eax,[esi+imagebase]                                                                  
        mov     svd_imgbase,eax                      ; save the image base                             
                                                                                                     
        mov     eax,[esi+datadir]			
        mov     importtbl,eax
        mov     eax,[esi+edatadir]
        mov     exporttbl,eax
        
        xor     eax,eax                                                                              
        mov     ax, word ptr [esi+NtHeaderSize]        ; get header size                             
        add     eax,18h                                ; object table is here                        
        add     eax,esi                                                                              
        mov     objptr,eax                                                                           
        
	mov	eax,[esi+filealign]
	mov	file_alignment,eax
	
	push 	esi                
        mov     eax,objptr
        lea     edi,otable                                                         
        xor     ecx,ecx                                                            
        mov     cx,[esi+numObj]                          ; get number of objects   
otbl_loop:
        cmp     edi,offset otable_end-8                  ; filled up table?
        jz      next_obj            
        call    test_obj                                 ; see if good obj name
        jc      next_obj
        pushad                                      
        call    lstrcat,offset eobj_txt,offset cr_lf_tab
        popad
        pushad
        call    lstrcat,offset eobj_txt,eax
        popad                
        push    eax ecx 
        mov     ebx,eax[objflags]                        ; get obj flags
        or      ebx,oflag_write                           ; OR in writable flag 
        mov     eax[objflags],ebx                        ; save new object flags
        mov     ebx,eax[objrva]                          ; get the object's rva        
        add	ebx,svd_imgbase
        mov     [edi],ebx                                ; save it
        push    edi                                                                                    
        mov     esi,eax[objpoff]                         ; esi->object physical offset          
        add     esi,map_ptr                                                                     
        mov     edi,esi                                                                         
        push	eax
        mov	ecx,eax[objvsize]
        mov	edx,eax[objpsize]
        cmp	ecx,edx
        jbe	vsize_less_psize_alright
	mov	ecx,edx        
vsize_less_psize_alright:        	
        call    compress_object                 ; compress object     
        push	eax
        call    file_align_fix			; go align da shiznit
        pop	ecx edx        
        mov	ebx,edx[objpsize]
        cmp	ebx,largest_needed_buffer
        jbe	no_update_largest
	mov	largest_needed_buffer,ebx        
no_update_largest: 
	pop	edi        		
        mov	edx[objpsize],eax	        
        mov	[edi+4],ecx
        add	edi,8
        pop     ecx eax                                                                             	
next_obj:    
        add     eax,40                                   ; increment to next object record    
        loop    otbl_loop
done_otbl:    
        pop     esi                                       ; restore ptr pe hdr   
                                                                                    
        sub     eax,40
        
; make sure nuff room to add another object before we ask if
; the user wants to. dunno if this is best way to do it, but I
; just scan to make sure the next 40 bytes (1 object record) are
; all 0.
        
        ;pushad        
        ;mov     edi,eax
        ;add     edi,40
        ;mov 	ecx,40
        ;xor	eax,eax
 	;repz    scasb
 	;or      ecx,ecx
 	;jz 	go_append 	
        
        ;call    MessageBoxA,0,offset append_question,offset caption,MB_ICONQUESTION or MB_YESNO
        ;cmp     eax,IDNO
        ;jz      go_append       
        ;cmp     eax,IDCANCEL
        ;jnz     go_create
        ;popad
        ;mov     error,-4
        ;jmp     abort_encrypt
go_create:        
; user selected to create new object
        ;popad                       	    
        ;mov     ecx,[eax+objrva]        	; get last object rva
        ;add     ecx,[eax+objvsize]		; +=last object virtual size
        ;push    eax				; save obj record ptr
        ;xchg    ecx,eax				; eax=last object virtual end
        ;mov     ecx,[esi+objalign]		; ecx=object alignment
        ;call    align_fix			; go align da shiznit
        ;xchg    ecx,eax                		; ecx=next object's rva
        ;pop     eax               		; restore obj record ptr
        ;mov     edx,[eax+objpoff]		; edx=last object physical offset
        ;add     edx,[eax+objpsize]      	; edx+=last object psize=obj pend
        ;add     eax,40				; goto next object in table (new)
        ;mov     dword ptr [eax],'sgv.'		; set object name to .vgc
        ;mov     dword ptr [eax+objpsize],0	; set psize to 0, updated later
        ;mov     dword ptr [eax+objvsize],0	; set vsize to 0, update later
        ;mov     [eax+objrva],ecx		; set rva of object
        ;mov     [eax+objpoff],edx       	; set physical offset of obj
        ;inc     word ptr [esi+numObj]  		; increment number of objects
        ;jmp     after_apop
        
        mov	edi,eax
        call    lstrcat,offset obj_txt,edi 
                                                                                 
        mov     eax,[edi+objpoff]                       ; get object physical off
        mov     lastobjimageoff,eax                     ; save it                
        mov     ecx,[edi+objpsize]                      ; get object physical size   
        mov     originalpsize,ecx                       ; save it 4 later        
                                                                                 
        mov     eax,[edi+objvsize]                      ; get object virtual size
        mov     originalvsize,eax                       ; save it                    
        cmp     eax,ecx                                                          
        jge     psize_less_vsize                        ; padded space for alignment?
        mov     eax,ecx                                 ; set vsize to psize     
psize_less_vsize:
        add 	eax,VIRTUAL_SIZE                        ; add our virtual size                        
        add	eax,largest_needed_buffer                        
        mov 	dword ptr [edi+objvsize],eax            ; save new virtual size
        
        mov	ecx,originalpsize
        mov	eax,originalvsize                
        cmp	eax,ecx
        jbe	vsize_less_psize_whohoo
        mov	eax,ecx
        mov	originalvsize,ecx
vsize_less_psize_whohoo:                
        push	eax
        add     eax,DECRYPTOR_SIZE                      ; adjust physical size of object 
        mov     ecx,[esi+filealign]                                                      
        call    align_fix                               ; on file alignment              
        mov     [edi+objpsize],eax                                                               

        mov     ecx,dword ptr [esi+objalign]            ; get object alignment
        mov     eax,dword ptr [edi+objvsize]            ; add virtual size
        add     eax,dword ptr [edi+objrva]              ; +last object rva
        call    align_fix                              ; set on obj alignment
        mov     dword ptr [esi+imagesize],eax           ; save new imagesize  
            
	pop	eax        

        mov     [edi+objflags],0E0000020h               ; set object flags r/w/x/init data
        add     eax,[edi+objrva]                        ; add last object's RVA     
                                	                ; eax now RVA of decryptor code
        mov     ebx,[esi+entrypointRVA]                  ; get original entry         
        mov     [esi+entrypointRVA],eax                  ; put our RVA as entry               
                                                                                              
        add	ebx,svd_imgbase
        mov     [host_eip],ebx                           ; save it                    
                        
	push    esi
                
        mov     edi,map_ptr
        add     edi,originalvsize                        ; add original physical size
        add     edi,lastobjimageoff                      ; add object physical offset  
copy_to_hdr:        
        lea     esi,decryptor_code                       ; esi->decryptor code         
        mov     ecx,DECRYPTOR_SIZE                                                     
        rep     movsb                                                                  
                                                                                       
        pop     esi                                     ; restore ptr pe hdr               
                                                                                               
        mov     ecx,[esi+filealign]                     ; calculate amt                         
        sub     ecx,DECRYPTOR_SIZE                       ; of padding needed                    
        xor     eax,eax                                                                     
        rep     stosb                                    ; pad up object to alignment       
                                                                                                                                                                               
        call    unmap                                   ; unmap file                     
                                                                                                
        mov     error,0                                ; if we made it here then no error
        jmp     unmapped                                
abort_encrypt:
        call    unmap                                  ;unmap if aborted infection
unmapped:
        
        call    SetFileTime,handle,offset lastwrite,offset lastaccess,offset creation                    
                                                                                     
        mov	edx,fsize
        lea	edi,a_org_size
        call	write_decimal
        
        cmp	error,0
        jnz	skip_align2
        mov	eax,handle
        push	eax			       ; save for close
        call	AlignFile 
skip_align2:               

        mov	edx,fsize
        lea	edi,a_new_size
        call	write_decimal
        
        call	lstrcat,offset size_txt,offset a_org_size
        call	lstrcat,offset size_txt,offset inter
        call	lstrcat,offset size_txt,offset a_new_size
                
        call    CloseHandle			; handle on stack
        
        call    SetFileAttributesA,fnameptr,oldattrib                    ; restore the original attributes                        
        ret                                 
CompressFile endp

; returns eax=new physical size
compress_object proc	                	
        push	ecx esi ecx
        call	GlobalAlloc,64,ecx
        mov	p_lz_mem,eax
        pop	ecx
        call	LZRW1_COMPRESS,offset csize,eax,ecx,esi
        pop	edi ecx        
        ;mov	ecx,csize
    	mov 	esi,p_lz_mem    	
    	rep	movsb    	    	
        call	GlobalFree,p_lz_mem
        mov	eax,csize        
	ret        
compress_object endp

test_obj proc    
        cmp     dword ptr [eax+objpoff],0       ; make sure physical offset isn't 0
        jz      ret_stc 
        cmp     dword ptr [eax+objpsize],0      ; make sure physical size isn't 0
        jz      ret_stc
	call    test_rvas
	jc      ret_stc	
        lea     esi,bad_otbl                     ; scan thru bad obj    
bobj_loop:                                       ; table
        xchg    eax,ebx
        lodsd
        xchg    eax,ebx
        cmp     ebx,[eax]
        jz      ret_stc                                                         
        or      ebx,ebx
        jnz     bobj_loop
        clc
        ret
ret_stc:
        stc    
        ret
test_obj endp    

test_rvas proc
        pushad
        mov     ecx,2        
        lea     esi,importtbl        
rva_loop:        
	mov     edx,dword ptr [esi]        
        mov     ebx,dword ptr [eax+objrva]        
        cmp     ebx,edx
        jg      not_bad
        jz      ret_stc2
        mov     ebx,dword ptr [eax+40+objrva]
        or      ebx,ebx
        jz	ret_stc
        cmp     ebx,edx
        jg      ret_stc2
not_bad:        
        add     esi,4
	loop    rva_loop
	popad
        clc
        ret
ret_stc2:
	popad
	stc
	ret                
endp


GetPEHeader proc
        mov     esi,[eax+3Ch]                        ; where PE hdr pointer is 
        add     esi,eax                                                        
        mov     ptrpeheader,esi                      ; esi->PE Hdr             
        ret
GetPEHeader endp

; create_mapping - create file mapping of [handle]
; entry: ecx=+adjust mapping size
;
create_mapping proc
        push    ecx                                ; save additional mapping size  
        call    GetFileSize,handle,0
        call    test_error                                                            
        jc      create_abort                                                          
        mov     fsize,eax                                                             
       
        pop     ecx                     ; restore map size
                
        add     eax,ecx
        call    CreateFileMappingA,handle,0,PAGE_READWRITE,0,eax,0
        call    test_error                   
        jc      create_abort
        mov     maphandle,eax
        
        call    MapViewOfFile,eax,FILE_MAP_WRITE,0,0,0
        call    test_error                                        
        jc      create_abort
        mov     map_ptr,eax
create_abort:
        ret
create_mapping endp


; test_error - test API for an error return
;  entry: eax=API return
;  returns: carry if error
;
test_error proc
        cmp     eax,-1 
        jz      api_err
        or      eax,eax
        jz      api_err
        clc
        ret
api_err:
        stc
        ret
test_error endp

; unmap file - Unmap view of file
; 
unmap proc
          
        call    UnmapViewOfFile,map_ptr  
        call    CloseHandle,maphandle
        ret

unmap endp

; sets eax on alignment of ecx
;
file_align_fix:
	mov	ecx,file_alignment	
align_fix proc  
        xor     edx,edx                                                                    
        div     ecx                               ; /alignment                                  
        or      edx,edx				  ; if no remainder then no next
        jz      no_adjust
        inc     eax                               ; next alignment                                
no_adjust:        
        mul     ecx                               ; *alignment                             
        ret
align_fix endp     

OpenFile proc
        call    CreateFileA,esi,0c0000000h,0,0,3,20h,0                                      
        ret
OpenFile endp

newalign equ 200h
;-----------------------------------------------
; align file 
; call with eax=handle
;
AlignFile proc

        mov     handle,eax                                                          
                                                                                                                                                                        
        xor     ecx,ecx                                ; only map size of file      
        call    create_mapping                        ; create file mapping         
        jc      abort_encrypt                                                       
        mov     ecx,fsize
        or	ecx,ecx					; no file size?
        jz	abort_align
        mov 	org_fsize,ecx
                                               ; eax->mapped file                
                                                                                    
        call    GetPEHeader                           ; load esi->PE Header         
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
	mov	eax,[esi+filealign]
	mov	orgalign,eax	
was_same:
        xor     eax,eax                                                                              
        mov     ax, word ptr [esi+NtHeaderSize]        ; get header size                             
        add     eax,18h                                ; object table is here                        
        add     eax,esi                                                                                      
        	
	push    eax				       ; save ptr to obj table
	xor     edx,edx				  
	mov     ecx,40 
	xor     eax,eax
	mov     ax,[esi+numObj]
	inc     eax
	mul     ecx
	xchg    eax,ebx	
	pop 	eax	
	push    eax
	add     eax,ebx
	mov     ecx,[esi+filealign]
	call    align_fix
	xchg    ebx,eax					; ebx->phy. start of first obj
	pop 	eax
        
        mov 	ecx,ebx
        sub	ecx,map_ptr
        mov 	[esi+sizehdr],ecx			; save new total size of hdr        
        
        mov     ecx,newalign
        mov     [esi+filealign],ecx
                
        xor     ecx,ecx                                                            
        mov     cx,[esi+numObj]                         ; get number of objects           
	mov     edi,ebx					; edi->phy. start of first obj
; edi contains pointer to current writing address of the executable	
otbl_loop2:		
	push    eax ecx					
	mov     ecx,edi					; ecx->current obj poff
	sub     ecx,map_ptr				; get real obj poff
	mov     esi,[eax+objpoff]			; esi->original obj p. off
	mov     [eax+objpoff],ecx			; save new physical offset at cur
	mov	ebx,[eax+objvsize]			; get virtual size
	cmp     ebx,[eax+objpsize]			; bigger than physical size?
	jg      skip_align				; if so skip re-aligning this one
	mov     ecx,newalign				; ecx=200h
	push    eax 					; save obj rec ptr
	xchg    eax,ebx					; eax=object virtual size
	call    align_fix				; align that baby
	xchg    eax,ebx					; ebx=object virtual size
	pop 	eax					; restore obj ptr
	jmp     did_align				
skip_align:		
	mov     ebx,[eax+objpsize]			; use psize if vsize>psize
did_align:
	mov     [eax+objpsize],ebx			; save new aligned physical size
	add     esi,map_ptr				; set esi into mapping
	mov     ecx,ebx				 	; ecx=physical size
	rep     movsb					; store object at new|old location
next_obj2:
	pop     ecx eax					
	add     eax,40					; onto next object ..whohoo
	loop    otbl_loop2	
		
	sub     eax,40					; adjust to last object
	mov     ecx,[eax+objpsize]			; ecx=last object physical size
	add     ecx,[eax+objpoff]			; ecx=total physical size of file
	push    ecx					

	call    unmap
		
	mov     error,0
	
        pop     ecx                                                                      
        mov     new_fsize,ecx
        call    SetFilePointer,handle,ecx,0,FILE_BEGIN  ; move file pointer to       
                                                 ;	 real EOF                                   
        call    SetEndOfFile,handle
        xor     ecx,ecx
        call    create_mapping
        jc      unmapped2
        call    GetPEHeader
        lea     eax,[esi+checksum]
        call    CheckSumMappedFile,map_ptr,fsize,offset oldchksum,eax
        call    unmap
        
        mov     error,0                                ; if we made it here then no error
        jmp     unmapped2                                
abort_align:
        call    unmap                                  ;unmap if aborted infection
unmapped2:
                                                                                     
        call    CloseHandle,handle                                                                          
        ret                                 
AlignFile endp

write_decimal proc
	push	edi
	mov	ecx,3
	xor	eax,eax
	rep	stosd
	pop	edi
    	mov 	eax,edx
    	mov 	esi,10
    	xor 	ecx,ecx
nz:
	xor 	edx,edx
    	div 	esi
    	push 	edx
    	inc 	ecx
    	or 	eax,eax
    	jnz 	nz
wdl:
    	pop 	edx
    	add 	dl,'0'
    	mov 	al,dl
    	stosb
    	loop wdl
	ret           
write_decimal endp

include LZRW1COMP.ASM

end start
ends

